Index: dnspython-1.12.0/dns/_compat.py
===================================================================
--- /dev/null
+++ dnspython-1.12.0/dns/_compat.py
@@ -0,0 +1,26 @@
+import sys
+
+
+if sys.version_info > (3,):
+    long = int
+    xrange = range
+else:
+    long = long
+    xrange = xrange
+
+# unicode / binary types
+if sys.version_info > (3,):
+    text_type = str
+    binary_type = bytes
+    string_types = (str,)
+    def xcmp(a, b):
+        if isinstance(a, str):
+            a = a.encode()
+        if isinstance(b, str):
+            b = b.encode()
+        return (a > b) - (a < b)
+else:
+    text_type = unicode
+    binary_type = str
+    string_types = (basestring,)
+    xcmp = cmp
Index: dnspython-1.12.0/dns/dnssec.py
===================================================================
--- dnspython-1.12.0.orig/dns/dnssec.py
+++ dnspython-1.12.0/dns/dnssec.py
@@ -15,7 +15,7 @@
 
 """Common DNSSEC-related functions and constants."""
 
-import cStringIO
+from io import BytesIO
 import struct
 import time
 
@@ -27,6 +27,7 @@ import dns.rdataset
 import dns.rdata
 import dns.rdatatype
 import dns.rdataclass
+from ._compat import string_types
 
 class UnsupportedAlgorithm(dns.exception.DNSException):
     """Raised if an algorithm is not supported."""
@@ -52,27 +53,28 @@ PRIVATEDNS = 253
 PRIVATEOID = 254
 
 _algorithm_by_text = {
-    'RSAMD5' : RSAMD5,
-    'DH' : DH,
-    'DSA' : DSA,
-    'ECC' : ECC,
-    'RSASHA1' : RSASHA1,
-    'DSANSEC3SHA1' : DSANSEC3SHA1,
-    'RSASHA1NSEC3SHA1' : RSASHA1NSEC3SHA1,
-    'RSASHA256' : RSASHA256,
-    'RSASHA512' : RSASHA512,
-    'INDIRECT' : INDIRECT,
-    'ECDSAP256SHA256' : ECDSAP256SHA256,
-    'ECDSAP384SHA384' : ECDSAP384SHA384,
-    'PRIVATEDNS' : PRIVATEDNS,
-    'PRIVATEOID' : PRIVATEOID,
-    }
+    'RSAMD5': RSAMD5,
+    'DH': DH,
+    'DSA': DSA,
+    'ECC': ECC,
+    'RSASHA1': RSASHA1,
+    'DSANSEC3SHA1': DSANSEC3SHA1,
+    'RSASHA1NSEC3SHA1': RSASHA1NSEC3SHA1,
+    'RSASHA256': RSASHA256,
+    'RSASHA512': RSASHA512,
+    'INDIRECT': INDIRECT,
+    'ECDSAP256SHA256': ECDSAP256SHA256,
+    'ECDSAP384SHA384': ECDSAP384SHA384,
+    'PRIVATEDNS': PRIVATEDNS,
+    'PRIVATEOID': PRIVATEOID,
+}
 
 # We construct the inverse mapping programmatically to ensure that we
 # cannot make any mistakes (e.g. omissions, cut-and-paste errors) that
 # would cause the mapping not to be true inverse.
 
-_algorithm_by_value = dict([(y, x) for x, y in _algorithm_by_text.iteritems()])
+_algorithm_by_value = dict((y, x) for x, y in _algorithm_by_text.items())
+
 
 def algorithm_from_text(text):
     """Convert text into a DNSSEC algorithm value
@@ -83,6 +85,7 @@ def algorithm_from_text(text):
         value = int(text)
     return value
 
+
 def algorithm_to_text(value):
     """Convert a DNSSEC algorithm value to text
     @rtype: string"""
@@ -92,35 +95,40 @@ def algorithm_to_text(value):
         text = str(value)
     return text
 
+
 def _to_rdata(record, origin):
-    s = cStringIO.StringIO()
+    s = BytesIO()
     record.to_wire(s, origin=origin)
     return s.getvalue()
 
+
 def key_id(key, origin=None):
     rdata = _to_rdata(key, origin)
+    rdata = bytearray(rdata)
     if key.algorithm == RSAMD5:
-        return (ord(rdata[-3]) << 8) + ord(rdata[-2])
+        return (rdata[-3] << 8) + rdata[-2]
     else:
         total = 0
         for i in range(len(rdata) // 2):
-            total += (ord(rdata[2 * i]) << 8) + ord(rdata[2 * i + 1])
+            total += (rdata[2 * i] << 8) + \
+                rdata[2 * i + 1]
         if len(rdata) % 2 != 0:
-            total += ord(rdata[len(rdata) - 1]) << 8
-        total += ((total >> 16) & 0xffff);
+            total += rdata[len(rdata) - 1] << 8
+        total += ((total >> 16) & 0xffff)
         return total & 0xffff
 
+
 def make_ds(name, key, algorithm, origin=None):
     if algorithm.upper() == 'SHA1':
         dsalg = 1
-        hash = dns.hash.get('SHA1')()
+        hash = dns.hash.hashes['SHA1']()
     elif algorithm.upper() == 'SHA256':
         dsalg = 2
-        hash = dns.hash.get('SHA256')()
+        hash = dns.hash.hashes['SHA256']()
     else:
-        raise UnsupportedAlgorithm, 'unsupported algorithm "%s"' % algorithm
+        raise UnsupportedAlgorithm('unsupported algorithm "%s"' % algorithm)
 
-    if isinstance(name, (str, unicode)):
+    if isinstance(name, string_types):
         name = dns.name.from_text(name, origin)
     hash.update(name.canonicalize().to_wire())
     hash.update(_to_rdata(key, origin))
@@ -130,8 +138,9 @@ def make_ds(name, key, algorithm, origin
     return dns.rdata.from_wire(dns.rdataclass.IN, dns.rdatatype.DS, dsrdata, 0,
                                len(dsrdata))
 
+
 def _find_candidate_keys(keys, rrsig):
-    candidate_keys=[]
+    candidate_keys = []
     value = keys.get(rrsig.signer)
     if value is None:
         return None
@@ -145,49 +154,59 @@ def _find_candidate_keys(keys, rrsig):
         rdataset = value
     for rdata in rdataset:
         if rdata.algorithm == rrsig.algorithm and \
-               key_id(rdata) == rrsig.key_tag:
+                key_id(rdata) == rrsig.key_tag:
             candidate_keys.append(rdata)
     return candidate_keys
 
+
 def _is_rsa(algorithm):
     return algorithm in (RSAMD5, RSASHA1,
                          RSASHA1NSEC3SHA1, RSASHA256,
                          RSASHA512)
 
+
 def _is_dsa(algorithm):
     return algorithm in (DSA, DSANSEC3SHA1)
 
+
 def _is_ecdsa(algorithm):
     return _have_ecdsa and (algorithm in (ECDSAP256SHA256, ECDSAP384SHA384))
 
+
 def _is_md5(algorithm):
     return algorithm == RSAMD5
 
+
 def _is_sha1(algorithm):
     return algorithm in (DSA, RSASHA1,
                          DSANSEC3SHA1, RSASHA1NSEC3SHA1)
 
+
 def _is_sha256(algorithm):
     return algorithm in (RSASHA256, ECDSAP256SHA256)
 
+
 def _is_sha384(algorithm):
     return algorithm == ECDSAP384SHA384
 
+
 def _is_sha512(algorithm):
     return algorithm == RSASHA512
 
+
 def _make_hash(algorithm):
     if _is_md5(algorithm):
-        return dns.hash.get('MD5')()
+        return dns.hash.hashes['MD5']()
     if _is_sha1(algorithm):
-        return dns.hash.get('SHA1')()
+        return dns.hash.hashes['SHA1']()
     if _is_sha256(algorithm):
-        return dns.hash.get('SHA256')()
+        return dns.hash.hashes['SHA256']()
     if _is_sha384(algorithm):
-        return dns.hash.get('SHA384')()
+        return dns.hash.hashes['SHA384']()
     if _is_sha512(algorithm):
-        return dns.hash.get('SHA512')()
-    raise ValidationFailure, 'unknown hash for algorithm %u' % algorithm
+        return dns.hash.hashes['SHA512']()
+    raise ValidationFailure('unknown hash for algorithm %u' % algorithm)
+
 
 def _make_algorithm_id(algorithm):
     if _is_md5(algorithm):
@@ -199,13 +218,14 @@ def _make_algorithm_id(algorithm):
     elif _is_sha512(algorithm):
         oid = [0x60, 0x86, 0x48, 0x01, 0x65, 0x03, 0x04, 0x02, 0x03]
     else:
-        raise ValidationFailure, 'unknown algorithm %u' % algorithm
+        raise ValidationFailure('unknown algorithm %u' % algorithm)
     olen = len(oid)
     dlen = _make_hash(algorithm).digest_size
     idbytes = [0x30] + [8 + olen + dlen] + \
               [0x30, olen + 4] + [0x06, olen] + oid + \
               [0x05, 0x00] + [0x04, dlen]
-    return ''.join(map(chr, idbytes))
+    return struct.pack('!%dB' % len(idbytes), *idbytes)
+
 
 def _validate_rrsig(rrset, rrsig, keys, origin=None, now=None):
     """Validate an RRset against a single signature rdata
@@ -219,7 +239,8 @@ def _validate_rrsig(rrset, rrsig, keys,
     @param rrsig: The signature rdata
     @type rrsig: dns.rrset.Rdata
     @param keys: The key dictionary.
-    @type keys: a dictionary keyed by dns.name.Name with node or rdataset values
+    @type keys: a dictionary keyed by dns.name.Name with node or rdataset
+    values
     @param origin: The origin to use for relative names
     @type origin: dns.name.Name or None
     @param now: The time to use when validating the signatures.  The default
@@ -227,15 +248,15 @@ def _validate_rrsig(rrset, rrsig, keys,
     @type now: int
     """
 
-    if isinstance(origin, (str, unicode)):
+    if isinstance(origin, string_types):
         origin = dns.name.from_text(origin, dns.name.root)
 
     for candidate_key in _find_candidate_keys(keys, rrsig):
         if not candidate_key:
-            raise ValidationFailure, 'unknown key'
+            raise ValidationFailure('unknown key')
 
-        # For convenience, allow the rrset to be specified as a (name, rdataset)
-        # tuple as well as a proper rrset
+        # For convenience, allow the rrset to be specified as a (name,
+        # rdataset) tuple as well as a proper rrset
         if isinstance(rrset, tuple):
             rrname = rrset[0]
             rdataset = rrset[1]
@@ -246,21 +267,21 @@ def _validate_rrsig(rrset, rrsig, keys,
         if now is None:
             now = time.time()
         if rrsig.expiration < now:
-            raise ValidationFailure, 'expired'
+            raise ValidationFailure('expired')
         if rrsig.inception > now:
-            raise ValidationFailure, 'not yet valid'
+            raise ValidationFailure('not yet valid')
 
         hash = _make_hash(rrsig.algorithm)
 
         if _is_rsa(rrsig.algorithm):
             keyptr = candidate_key.key
-            (bytes,) = struct.unpack('!B', keyptr[0:1])
+            (bytes_,) = struct.unpack('!B', keyptr[0:1])
             keyptr = keyptr[1:]
-            if bytes == 0:
-                (bytes,) = struct.unpack('!H', keyptr[0:2])
+            if bytes_ == 0:
+                (bytes_,) = struct.unpack('!H', keyptr[0:2])
                 keyptr = keyptr[2:]
-            rsa_e = keyptr[0:bytes]
-            rsa_n = keyptr[bytes:]
+            rsa_e = keyptr[0:bytes_]
+            rsa_n = keyptr[bytes_:]
             keylen = len(rsa_n) * 8
             pubkey = Crypto.PublicKey.RSA.construct(
                 (Crypto.Util.number.bytes_to_long(rsa_n),
@@ -290,14 +311,12 @@ def _validate_rrsig(rrset, rrsig, keys,
             if rrsig.algorithm == ECDSAP256SHA256:
                 curve = ecdsa.curves.NIST256p
                 key_len = 32
-                digest_len = 32
             elif rrsig.algorithm == ECDSAP384SHA384:
                 curve = ecdsa.curves.NIST384p
                 key_len = 48
-                digest_len = 48
             else:
                 # shouldn't happen
-                raise ValidationFailure, 'unknown ECDSA curve'
+                raise ValidationFailure('unknown ECDSA curve')
             keyptr = candidate_key.key
             x = Crypto.Util.number.bytes_to_long(keyptr[0:key_len])
             y = Crypto.Util.number.bytes_to_long(keyptr[key_len:key_len * 2])
@@ -311,7 +330,7 @@ def _validate_rrsig(rrset, rrsig, keys,
             sig = ecdsa.ecdsa.Signature(Crypto.Util.number.bytes_to_long(r),
                                         Crypto.Util.number.bytes_to_long(s))
         else:
-            raise ValidationFailure, 'unknown algorithm %u' % rrsig.algorithm
+            raise ValidationFailure('unknown algorithm %u' % rrsig.algorithm)
 
         hash.update(_to_rdata(rrsig, origin)[:18])
         hash.update(rrsig.signer.to_digestable(origin))
@@ -322,7 +341,7 @@ def _validate_rrsig(rrset, rrsig, keys,
         rrnamebuf = rrname.to_digestable(origin)
         rrfixed = struct.pack('!HHI', rdataset.rdtype, rdataset.rdclass,
                               rrsig.original_ttl)
-        rrlist = sorted(rdataset);
+        rrlist = sorted(rdataset)
         for rr in rrlist:
             hash.update(rrnamebuf)
             hash.update(rrfixed)
@@ -337,18 +356,20 @@ def _validate_rrsig(rrset, rrsig, keys,
             # PKCS1 algorithm identifier goop
             digest = _make_algorithm_id(rrsig.algorithm) + digest
             padlen = keylen // 8 - len(digest) - 3
-            digest = chr(0) + chr(1) + chr(0xFF) * padlen + chr(0) + digest
+            digest = struct.pack('!%dB' % (2 + padlen + 1),
+                                 *([0, 1] + [0xFF] * padlen + [0])) + digest
         elif _is_dsa(rrsig.algorithm) or _is_ecdsa(rrsig.algorithm):
             pass
         else:
             # Raise here for code clarity; this won't actually ever happen
             # since if the algorithm is really unknown we'd already have
             # raised an exception above
-            raise ValidationFailure, 'unknown algorithm %u' % rrsig.algorithm
+            raise ValidationFailure('unknown algorithm %u' % rrsig.algorithm)
 
         if pubkey.verify(digest, sig):
             return
-    raise ValidationFailure, 'verify failure'
+    raise ValidationFailure('verify failure')
+
 
 def _validate(rrset, rrsigset, keys, origin=None, now=None):
     """Validate an RRset
@@ -360,7 +381,8 @@ def _validate(rrset, rrsigset, keys, ori
     @type rrsigset: dns.rrset.RRset or (dns.name.Name, dns.rdataset.Rdataset)
     tuple
     @param keys: The key dictionary.
-    @type keys: a dictionary keyed by dns.name.Name with node or rdataset values
+    @type keys: a dictionary keyed by dns.name.Name with node or rdataset
+    values
     @param origin: The origin to use for relative names
     @type origin: dns.name.Name or None
     @param now: The time to use when validating the signatures.  The default
@@ -368,7 +390,7 @@ def _validate(rrset, rrsigset, keys, ori
     @type now: int
     """
 
-    if isinstance(origin, (str, unicode)):
+    if isinstance(origin, string_types):
         origin = dns.name.from_text(origin, dns.name.root)
 
     if isinstance(rrset, tuple):
@@ -386,18 +408,19 @@ def _validate(rrset, rrsigset, keys, ori
     rrname = rrname.choose_relativity(origin)
     rrsigname = rrname.choose_relativity(origin)
     if rrname != rrsigname:
-        raise ValidationFailure, "owner names do not match"
+        raise ValidationFailure("owner names do not match")
 
     for rrsig in rrsigrdataset:
         try:
             _validate_rrsig(rrset, rrsig, keys, origin, now)
             return
-        except ValidationFailure, e:
+        except ValidationFailure:
             pass
-    raise ValidationFailure, "no RRSIGs validated"
+    raise ValidationFailure("no RRSIGs validated")
+
 
 def _need_pycrypto(*args, **kwargs):
-    raise NotImplementedError, "DNSSEC validation requires pycrypto"
+    raise NotImplementedError("DNSSEC validation requires pycrypto")
 
 try:
     import Crypto.PublicKey.RSA
@@ -419,9 +442,11 @@ try:
     _have_ecdsa = True
 
     class ECKeyWrapper(object):
+
         def __init__(self, key, key_len):
             self.key = key
             self.key_len = key_len
+
         def verify(self, digest, sig):
             diglong = Crypto.Util.number.bytes_to_long(digest)
             return self.key.pubkey.verifies(diglong, sig)
Index: dnspython-1.12.0/dns/e164.py
===================================================================
--- dnspython-1.12.0.orig/dns/e164.py
+++ dnspython-1.12.0/dns/e164.py
@@ -19,12 +19,15 @@
 @type public_enum_domain: dns.name.Name object
 """
 
+
 import dns.exception
 import dns.name
 import dns.resolver
+from ._compat import string_types
 
 public_enum_domain = dns.name.from_text('e164.arpa.')
 
+
 def from_e164(text, origin=public_enum_domain):
     """Convert an E.164 number in textual form into a Name object whose
     value is the ENUM domain name for that number.
@@ -39,6 +42,7 @@ def from_e164(text, origin=public_enum_d
     parts.reverse()
     return dns.name.from_text('.'.join(parts), origin=origin)
 
+
 def to_e164(name, origin=public_enum_domain, want_plus_prefix=True):
     """Convert an ENUM domain name into an E.164 number.
     @param name: the ENUM domain name.
@@ -50,17 +54,18 @@ def to_e164(name, origin=public_enum_dom
     returned number.
     @rtype: str
     """
-    if not origin is None:
+    if origin is not None:
         name = name.relativize(origin)
     dlabels = [d for d in name.labels if (d.isdigit() and len(d) == 1)]
     if len(dlabels) != len(name.labels):
         raise dns.exception.SyntaxError('non-digit labels in ENUM domain name')
     dlabels.reverse()
-    text = ''.join(dlabels)
+    text = b''.join(dlabels)
     if want_plus_prefix:
-        text = '+' + text
+        text = b'+' + text
     return text
 
+
 def query(number, domains, resolver=None):
     """Look for NAPTR RRs for the specified number in the specified domains.
 
@@ -69,7 +74,7 @@ def query(number, domains, resolver=None
     if resolver is None:
         resolver = dns.resolver.get_default_resolver()
     for domain in domains:
-        if isinstance(domain, (str, unicode)):
+        if isinstance(domain, string_types):
             domain = dns.name.from_text(domain)
         qname = dns.e164.from_e164(number, domain)
         try:
Index: dnspython-1.12.0/dns/edns.py
===================================================================
--- dnspython-1.12.0.orig/dns/edns.py
+++ dnspython-1.12.0/dns/edns.py
@@ -14,10 +14,12 @@
 # OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 
 """EDNS Options"""
-
+from dns._compat import xcmp
 NSID = 3
 
+
 class Option(object):
+
     """Base class for all EDNS option types.
     """
 
@@ -33,6 +35,7 @@ class Option(object):
         """
         raise NotImplementedError
 
+    @classmethod
     def from_wire(cls, otype, wire, current, olen):
         """Build an EDNS option object from wire format
 
@@ -47,11 +50,10 @@ class Option(object):
         @rtype: dns.edns.Option instance"""
         raise NotImplementedError
 
-    from_wire = classmethod(from_wire)
-
     def _cmp(self, other):
         """Compare an EDNS option with another option of the same type.
-        Return < 0 if self < other, 0 if self == other, and > 0 if self > other.
+        Return < 0 if self < other, 0 if self == other,
+        and > 0 if self > other.
         """
         raise NotImplementedError
 
@@ -71,30 +73,31 @@ class Option(object):
 
     def __lt__(self, other):
         if not isinstance(other, Option) or \
-               self.otype != other.otype:
+                self.otype != other.otype:
             return NotImplemented
         return self._cmp(other) < 0
 
     def __le__(self, other):
         if not isinstance(other, Option) or \
-               self.otype != other.otype:
+                self.otype != other.otype:
             return NotImplemented
         return self._cmp(other) <= 0
 
     def __ge__(self, other):
         if not isinstance(other, Option) or \
-               self.otype != other.otype:
+                self.otype != other.otype:
             return NotImplemented
         return self._cmp(other) >= 0
 
     def __gt__(self, other):
         if not isinstance(other, Option) or \
-               self.otype != other.otype:
+                self.otype != other.otype:
             return NotImplemented
         return self._cmp(other) > 0
 
 
 class GenericOption(Option):
+
     """Generate Rdata Class
 
     This class is used for EDNS option types for which we have no better
@@ -108,13 +111,12 @@ class GenericOption(Option):
     def to_wire(self, file):
         file.write(self.data)
 
+    @classmethod
     def from_wire(cls, otype, wire, current, olen):
         return cls(otype, wire[current : current + olen])
 
-    from_wire = classmethod(from_wire)
-
     def _cmp(self, other):
-	return cmp(self.data, other.data)
+        return xcmp(self.data, other.data)
 
 _type_to_class = {
 }
Index: dnspython-1.12.0/dns/entropy.py
===================================================================
--- dnspython-1.12.0.orig/dns/entropy.py
+++ dnspython-1.12.0/dns/entropy.py
@@ -15,12 +15,15 @@
 
 import os
 import time
+from ._compat import long, binary_type
 try:
     import threading as _threading
 except ImportError:
     import dummy_threading as _threading
 
+
 class EntropyPool(object):
+
     def __init__(self, seed=None):
         self.pool_index = 0
         self.digest = None
@@ -39,9 +42,9 @@ class EntropyPool(object):
                 import md5
                 self.hash = md5.new()
                 self.hash_len = 16
-        self.pool = '\0' * self.hash_len
-        if not seed is None:
-            self.stir(seed)
+        self.pool = bytearray(b'\0' * self.hash_len)
+        if seed is not None:
+            self.stir(bytearray(seed))
             self.seeded = True
         else:
             self.seeded = False
@@ -50,14 +53,12 @@ class EntropyPool(object):
         if not already_locked:
             self.lock.acquire()
         try:
-            bytes = [ord(c) for c in self.pool]
             for c in entropy:
                 if self.pool_index == self.hash_len:
                     self.pool_index = 0
-                b = ord(c) & 0xff
-                bytes[self.pool_index] ^= b
+                b = c & 0xff
+                self.pool[self.pool_index] ^= b
                 self.pool_index += 1
-            self.pool = ''.join([chr(c) for c in bytes])
         finally:
             if not already_locked:
                 self.lock.release()
@@ -68,7 +69,7 @@ class EntropyPool(object):
                 seed = os.urandom(16)
             except:
                 try:
-                    r = file('/dev/urandom', 'r', 0)
+                    r = open('/dev/urandom', 'rb', 0)
                     try:
                         seed = r.read(16)
                     finally:
@@ -76,18 +77,19 @@ class EntropyPool(object):
                 except:
                     seed = str(time.time())
             self.seeded = True
+            seed = bytearray(seed)
             self.stir(seed, True)
 
     def random_8(self):
         self.lock.acquire()
-        self._maybe_seed()
         try:
+            self._maybe_seed()
             if self.digest is None or self.next_byte == self.hash_len:
-                self.hash.update(self.pool)
-                self.digest = self.hash.digest()
+                self.hash.update(binary_type(self.pool))
+                self.digest = bytearray(self.hash.digest())
                 self.stir(self.digest, True)
                 self.next_byte = 0
-            value = ord(self.digest[self.next_byte])
+            value = self.digest[self.next_byte]
             self.next_byte += 1
         finally:
             self.lock.release()
@@ -101,23 +103,25 @@ class EntropyPool(object):
 
     def random_between(self, first, last):
         size = last - first + 1
-        if size > 4294967296L:
+        if size > long(4294967296):
             raise ValueError('too big')
         if size > 65536:
             rand = self.random_32
-            max = 4294967295L
+            max = long(4294967295)
         elif size > 256:
             rand = self.random_16
             max = 65535
         else:
             rand = self.random_8
             max = 255
-	return (first + size * rand() // (max + 1))
+        return (first + size * rand() // (max + 1))
 
 pool = EntropyPool()
 
+
 def random_16():
     return pool.random_16()
 
+
 def between(first, last):
     return pool.random_between(first, last)
Index: dnspython-1.12.0/dns/flags.py
===================================================================
--- dnspython-1.12.0.orig/dns/flags.py
+++ dnspython-1.12.0/dns/flags.py
@@ -30,17 +30,17 @@ CD = 0x0010
 DO = 0x8000
 
 _by_text = {
-    'QR' : QR,
-    'AA' : AA,
-    'TC' : TC,
-    'RD' : RD,
-    'RA' : RA,
-    'AD' : AD,
-    'CD' : CD
+    'QR': QR,
+    'AA': AA,
+    'TC': TC,
+    'RD': RD,
+    'RA': RA,
+    'AD': AD,
+    'CD': CD
 }
 
 _edns_by_text = {
-    'DO' : DO
+    'DO': DO
 }
 
 
@@ -48,12 +48,13 @@ _edns_by_text = {
 # cannot make any mistakes (e.g. omissions, cut-and-paste errors) that
 # would cause the mappings not to be true inverses.
 
-_by_value = dict([(y, x) for x, y in _by_text.iteritems()])
+_by_value = dict((y, x) for x, y in _by_text.items())
+
+_edns_by_value = dict((y, x) for x, y in _edns_by_text.items())
 
-_edns_by_value = dict([(y, x) for x, y in _edns_by_text.iteritems()])
 
 def _order_flags(table):
-    order = list(table.iteritems())
+    order = list(table.items())
     order.sort()
     order.reverse()
     return order
@@ -62,6 +63,7 @@ _flags_order = _order_flags(_by_value)
 
 _edns_flags_order = _order_flags(_edns_by_value)
 
+
 def _from_text(text, table):
     flags = 0
     tokens = text.split()
@@ -69,6 +71,7 @@ def _from_text(text, table):
         flags = flags | table[t.upper()]
     return flags
 
+
 def _to_text(flags, table, order):
     text_flags = []
     for k, v in order:
@@ -76,6 +79,7 @@ def _to_text(flags, table, order):
             text_flags.append(v)
     return ' '.join(text_flags)
 
+
 def from_text(text):
     """Convert a space-separated list of flag text values into a flags
     value.
@@ -83,13 +87,14 @@ def from_text(text):
 
     return _from_text(text, _by_text)
 
+
 def to_text(flags):
     """Convert a flags value into a space-separated list of flag text
     values.
     @rtype: string"""
 
     return _to_text(flags, _by_value, _flags_order)
-    
+
 
 def edns_from_text(text):
     """Convert a space-separated list of EDNS flag text values into a EDNS
@@ -98,6 +103,7 @@ def edns_from_text(text):
 
     return _from_text(text, _edns_by_text)
 
+
 def edns_to_text(flags):
     """Convert an EDNS flags value into a space-separated list of EDNS flag
     text values.
Index: dnspython-1.12.0/dns/grange.py
===================================================================
--- dnspython-1.12.0.orig/dns/grange.py
+++ dnspython-1.12.0/dns/grange.py
@@ -17,6 +17,7 @@
 
 import dns
 
+
 def from_text(text):
     """Convert the text form of a range in a GENERATE statement to an
     integer.
@@ -28,7 +29,6 @@ def from_text(text):
     """
     # TODO, figure out the bounds on start, stop and step.
 
-    import pdb
     step = 1
     cur = ''
     state = 0
Index: dnspython-1.12.0/dns/hash.py
===================================================================
--- dnspython-1.12.0.orig/dns/hash.py
+++ dnspython-1.12.0/dns/hash.py
@@ -16,52 +16,17 @@
 """Hashing backwards compatibility wrapper"""
 
 import sys
+import hashlib
 
-_hashes = None
 
-def _need_later_python(alg):
-    def func(*args, **kwargs):
-        raise NotImplementedError("TSIG algorithm " + alg +
-                                  " requires Python 2.5.2 or later")
-    return func
+hashes = {}
+hashes['MD5'] = hashlib.md5
+hashes['SHA1'] = hashlib.sha1
+hashes['SHA224'] = hashlib.sha224
+hashes['SHA256'] = hashlib.sha256
+hashes['SHA384'] = hashlib.sha384
+hashes['SHA512'] = hashlib.sha512
 
-def _setup():
-    global _hashes
-    _hashes = {}
-    try:
-        import hashlib
-        _hashes['MD5'] = hashlib.md5
-        _hashes['SHA1'] = hashlib.sha1
-        _hashes['SHA224'] = hashlib.sha224
-        _hashes['SHA256'] = hashlib.sha256
-        if sys.hexversion >= 0x02050200:
-            _hashes['SHA384'] = hashlib.sha384
-            _hashes['SHA512'] = hashlib.sha512
-        else:
-            _hashes['SHA384'] = _need_later_python('SHA384')
-            _hashes['SHA512'] = _need_later_python('SHA512')
-
-        if sys.hexversion < 0x02050000:
-            # hashlib doesn't conform to PEP 247: API for
-            # Cryptographic Hash Functions, which hmac before python
-            # 2.5 requires, so add the necessary items.
-            class HashlibWrapper:
-                def __init__(self, basehash):
-                    self.basehash = basehash
-                    self.digest_size = self.basehash().digest_size
-
-                def new(self, *args, **kwargs):
-                    return self.basehash(*args, **kwargs)
-
-            for name in _hashes:
-                _hashes[name] = HashlibWrapper(_hashes[name])
-
-    except ImportError:
-        import md5, sha
-        _hashes['MD5'] =  md5
-        _hashes['SHA1'] = sha
 
 def get(algorithm):
-    if _hashes is None:
-        _setup()
-    return _hashes[algorithm.upper()]
+    return hashes[algorithm.upper()]
Index: dnspython-1.12.0/dns/inet.py
===================================================================
--- dnspython-1.12.0.orig/dns/inet.py
+++ dnspython-1.12.0/dns/inet.py
@@ -34,6 +34,7 @@ try:
 except AttributeError:
     AF_INET6 = 9999
 
+
 def inet_pton(family, text):
     """Convert the textual form of a network address into its binary form.
 
@@ -45,7 +46,7 @@ def inet_pton(family, text):
     implemented.
     @rtype: string
     """
-    
+
     if family == AF_INET:
         return dns.ipv4.inet_aton(text)
     elif family == AF_INET6:
@@ -53,6 +54,7 @@ def inet_pton(family, text):
     else:
         raise NotImplementedError
 
+
 def inet_ntop(family, address):
     """Convert the binary form of a network address into its textual form.
 
@@ -71,6 +73,7 @@ def inet_ntop(family, address):
     else:
         raise NotImplementedError
 
+
 def af_for_address(text):
     """Determine the address family of a textual-form network address.
 
@@ -80,15 +83,16 @@ def af_for_address(text):
     @rtype: int
     """
     try:
-        junk = dns.ipv4.inet_aton(text)
+        dns.ipv4.inet_aton(text)
         return AF_INET
     except:
         try:
-            junk = dns.ipv6.inet_aton(text)
+            dns.ipv6.inet_aton(text)
             return AF_INET6
         except:
             raise ValueError
 
+
 def is_multicast(text):
     """Is the textual-form network address a multicast address?
 
@@ -105,4 +109,3 @@ def is_multicast(text):
             return (first == 255)
         except:
             raise ValueError
-    
Index: dnspython-1.12.0/dns/ipv4.py
===================================================================
--- dnspython-1.12.0.orig/dns/ipv4.py
+++ dnspython-1.12.0/dns/ipv4.py
@@ -18,6 +18,7 @@
 import struct
 
 import dns.exception
+from ._compat import binary_type
 
 def inet_ntoa(address):
     """Convert an IPv4 address in network form to text form.
@@ -28,8 +29,10 @@ def inet_ntoa(address):
     """
     if len(address) != 4:
         raise dns.exception.SyntaxError
-    return '%u.%u.%u.%u' % (ord(address[0]), ord(address[1]),
-                            ord(address[2]), ord(address[3]))
+    if not isinstance(address, bytearray):
+        address = bytearray(address)
+    return (u'%u.%u.%u.%u' % (address[0], address[1],
+                              address[2], address[3])).encode()
 
 def inet_aton(text):
     """Convert an IPv4 address in text form to network form.
@@ -38,7 +41,9 @@ def inet_aton(text):
     @type text: string
     @returns: string
     """
-    parts = text.split('.')
+    if not isinstance(text, binary_type):
+        text = text.encode()
+    parts = text.split(b'.')
     if len(parts) != 4:
         raise dns.exception.SyntaxError
     for part in parts:
